/* 1.4:2001/10/08: I𒆎Ԋԍcaۑǉ:              */

#include <PalmOS.h>

#include "timeTable.h"

#define AppID    'Tg03'
#define DBType   'Data'   // 0x64415441 in hexadecimal


#define TYPE   0x02
#define STSVER 0x01
#define STATUS_DB_INDEX 0x04

static void initCalcDB(DmOpenRef,UInt16,Schedule*);

//static UInt16	fileIndex = 0;//I𒆂̎ԊR[hԍ


Char  DBName[] = "TimeDB";

// 2001/10/8 Xe[^X\ *1.4*
typedef struct {
	UInt16 type;
	UInt16 ver;
	UInt16 fileIndex;//I𒆂̎ԊR[hԍ
}AppStatus;

static AppStatus appsts;

Boolean openDB(DmOpenRef *dbRef);

// 2001/10/8
// Xe[^X̏
//*1.4*
void initStatus()
{
	appsts.type      = TYPE;
	appsts.ver       = STSVER;
	appsts.fileIndex = 0;
}
// 2001/10/8
// Xe[^XDB
//*1.4*
void initStatusDB(DmOpenRef gDB)
{
	MemHandle	RecHandle;
	MemPtr		RecPointer;
	UInt16		index;
	
	index = STATUS_DB_INDEX;
	
	/*DB*/
    RecHandle = DmNewRecord(gDB, &index, sizeof(AppStatus));
    RecPointer = MemHandleLock(RecHandle);
    DmWrite(RecPointer, 0, &appsts, sizeof(AppStatus));
    MemHandleUnlock(RecHandle); 
    DmReleaseRecord(gDB, index, true);
}
// 2001/10/8
// Xe[^XDB
//*1.4*
void writeStatusDB(void)
{
	MemHandle	RecHandle;
	MemPtr		RecPointer;
	DmOpenRef	gDB;
	
	openDB(&gDB);
	
	RecHandle = DmGetRecord(gDB,STATUS_DB_INDEX);
    RecPointer = MemHandleLock(RecHandle);
    DmWrite(RecPointer,0,&appsts,sizeof(AppStatus));
    MemHandleUnlock(RecHandle);
    DmReleaseRecord(gDB, STATUS_DB_INDEX, true); 
    
    DmCloseDatabase(gDB);
}
// 2001/10/8
// Xe[^XDBǂݍ
//*1.4*
void readStatusDB(void)
{
	MemHandle	RecHandle;
	MemPtr		RecPointer;
	DmOpenRef	gDB;
	UInt16		index = STATUS_DB_INDEX;
	
	openDB(&gDB);
	
	RecHandle = DmQueryRecord(gDB, STATUS_DB_INDEX);

	if(RecHandle != NULL){
		RecPointer = MemHandleLock(RecHandle);
		MemMove(&appsts,RecPointer,sizeof(AppStatus));
		MemHandleUnlock(RecHandle);
	} else {
		//f[^x[Xɑ݂Ȃ(ver1.3.1ȑÕf[x[XcĂꍇ)
		RecHandle = DmNewRecord(gDB,&index,sizeof(AppStatus));
		RecPointer = MemHandleLock(RecHandle);
		DmWrite(RecPointer,0,&appsts,sizeof(AppStatus));
		MemHandleUnlock(RecHandle);
		DmReleaseRecord(gDB, index, true); 
    }
    
    DmCloseDatabase(gDB);
}
//
//I𒆂̎ԊR[hԍZbg
//
void setFileIdx(UInt16 idx)
{
//	fileIndex = idx;
	appsts.fileIndex = idx;	// *1.4*
	writeStatusDB();		// *1.4*
}
//
//I𒆂̎ԊR[hԍ̎擾
//
UInt16 getFileIdx()
{
	return appsts.fileIndex;
}
//
//f[^x[X̃I[v
//
Boolean openDB(DmOpenRef *dbRef)
{
	DmOpenRef	gDB;	
	Schedule *dbdata;
	
	dbdata = getSchedulePtr();
	
	gDB = DmOpenDatabaseByTypeCreator(DBType, AppID, dmModeReadWrite);
	if (!gDB) {
		/* f[^x[XVK쐬 */
		if (DmCreateDatabase(0, DBName,AppID,DBType, false)){
			return 1;
		}
		/* read & write ŃI[v*/
		gDB = DmOpenDatabaseByTypeCreator(DBType,AppID,dmModeReadWrite);
		if(!gDB){
			return DmGetLastErr();
		}
		/*  */
		initCalcDB(gDB,0,dbdata);
		initCalcDB(gDB,1,dbdata);
		initCalcDB(gDB,2,dbdata);
		initCalcDB(gDB,3,dbdata);
		initStatusDB(gDB);			// *1.4*
	}
    
    *dbRef = gDB;
    
    return true;
}
//
//
//
void readDBSchedule(Schedule *schedule)
{
	MemHandle	RecHandle;
	MemPtr		RecPointer;
	DmOpenRef	gDB;
	
	openDB(&gDB);
	
	RecHandle = DmQueryRecord(gDB, appsts.fileIndex);
	RecPointer = MemHandleLock(RecHandle);
	MemMove(schedule,RecPointer,sizeof(Schedule)); 
    MemHandleUnlock(RecHandle);
    
    DmCloseDatabase(gDB);
}
//
//
//
void writeDBSchedule(Schedule *schedule)
{
	MemHandle	RecHandle;
	MemPtr		RecPointer;
	DmOpenRef	gDB;
	
	openDB(&gDB);
	
	RecHandle = DmGetRecord(gDB,appsts.fileIndex);
    RecPointer = MemHandleLock(RecHandle);
    DmWrite(RecPointer,0,schedule,sizeof(Schedule));
    MemHandleUnlock(RecHandle);
    DmReleaseRecord(gDB, appsts.fileIndex, true); 
    
	DmCloseDatabase(gDB);
}
//
//
//
static void initCalcDB(DmOpenRef gDB,UInt16 idx,Schedule *initData)
{
	MemHandle	RecHandle;
	MemPtr		RecPointer;
	UInt16		index;
	
	index = idx;
	
	/*  */
    RecHandle = DmNewRecord(gDB, &index, sizeof(Schedule));
    RecPointer = MemHandleLock(RecHandle);
    DmWrite(RecPointer, 0, initData, sizeof(Schedule));
    MemHandleUnlock(RecHandle); 
    DmReleaseRecord(gDB, index, true);
}