/******************************************************************/
/*                                                                */
/*                       timeTable.c                              */
/*       Taiga Yonekura 2000 All Rights Reserved                  */
/******************************************************************/
/* Rev  :  DATE    : contents                      :name          */
/*------:----------:-------------------------------:--------------*/
/*      :2000/10/10: Ԋ\e[u            :Taiga Yonkura */
/* 1.1  :2001/03/03: n[h{^ǉ          :              */
/* 1.2  :2001/03/17: Ȗڏڍ׉ʕύX              :              */
/* 1.3  :2001/04/21: ꗗʃn[h{^ǉ  :              */
/* 1.3.1:2001/05/08: J-OSΉ              :              */
/*      :          :                               :              */
/******************************************************************/
#include <PalmOS.h>

#include "Comlib.h"
#include "timeRsc.h"
#include "timeset.h"
#include "timeTable.h"
#include "CalcInfo.h"

#define CULCSELLTYPE 1
#define TIMESELLTYPE 2

#define ARROWPOS_Y	150
#define ARROW1POS_X	0
#define ARROW2POS_X	10
#define ARROW3POS_X	20
#define ARROW4POS_X	33
#define ARROWSIZE	10

#define NO_ARROWCLICED 0
#define ARROW1_CLICKED 1
#define ARROW2_CLICKED 2
#define ARROW3_CLICKED 3
#define ARROW4_CLICKED 4


typedef struct{
	UInt16 width;		//P}X̉TCY
	UInt16 height;		//P}X̏cTCY
	UInt16 numX;		//̃}X̐
	UInt16 numY;		//̃}X̐
	
	UInt16 tablePosX;	//\Jnʒu
	UInt16 tablePosY;	//\Jnʒu
	
	UInt16 selectedIndx;//I𒆂̃Z̈ʒu
	UInt16 leftTopCalcIndex;//
	UInt16 leftTopTimeIndex;//
}TimeTable;



static void setStringsell(UInt16,Char*);
static Boolean checkClickSell(Int16 x,Int16 y,UInt16 *index);
//static UInt16 checkClickArrow(Int16 x,Int16 y);
static UInt16 getSellType(UInt16 sellIdx,UInt16 *ScheduleIdx);
static void slideSellData(UInt16 type);
static void drawCalcTime();
static void initCalcData();
static void drawDayString(UInt16 CalcIndex,Char *str);

static TimeTable timeTable;
static Schedule schedule;


//
//Ԋf[^̏
//
void initTimetable(UInt16 w,UInt16 h,UInt16 x,UInt16 y)
{
	
	timeTable.width  = w;
	timeTable.height = h;
	timeTable.numX   = x;
	timeTable.numY   = y;
	
	timeTable.tablePosX = TIMETBLPOS_X;
	timeTable.tablePosY = TIMETBLPOS_Y;
	
	timeTable.leftTopCalcIndex = 0;
	timeTable.leftTopTimeIndex = 0;
	
	initCalcData();
	
}
//
//Ԋf[^|C^̎擾
//	idayType:j@time:j
Curc* getCurcData(Char dayType,UInt16 time)
{
	UInt16 idx;
	if((dayType >= ONEWEEKDAY) || (time > ONEDAYMAXCALC)){
		 return NULL;/*1.2*/
	}
	idx = (time - 1) * ONEWEEKDAY + dayType;
	
	return &(schedule.curc[idx]);
}
//
//
//
UInt16 getleftTopCalcIndex()
{
	return timeTable.leftTopCalcIndex;
}
//
//̎擾
//
void getCalcTime(UInt16 idx,UInt16 *starttime,UInt16 *endtime)
{
	*starttime = schedule.time[idx].startTime;
	*endtime = schedule.time[idx].endTime;
}
//
//̓o^
//
void setCalcTime(UInt16 idx,UInt16 starttime,UInt16 endtime)
{
	schedule.time[idx].startTime = starttime;
	schedule.time[idx].endTime = endtime;
}
//
//Cʂ̕`
//
void drawTimetable()
{
	UInt16 i;
	UInt16 idx;
	
	ControlPtr ctl;
	Char day[4];
	
	//c
	for(i = 0;i <= timeTable.numX;i++){
		WinDrawLine(timeTable.tablePosX + i * timeTable.width,timeTable.tablePosY,
					timeTable.tablePosX + i * timeTable.width,timeTable.tablePosY + timeTable.numY * timeTable.height);
	}
	
	//
	for(i = 0;i <= timeTable.numY;i++){
		WinDrawLine(timeTable.tablePosX,timeTable.tablePosY + i * timeTable.height,
					timeTable.tablePosX + timeTable.numX * timeTable.width,timeTable.tablePosY + i * timeTable.height);
	}
	
	//Z̓e𖄂߂
	for(i = 0;i < timeTable.numX * timeTable.numY;i++){
		if(getSellType(i,&idx) == CULCSELLTYPE){
			setStringsell(i,schedule.curc[idx].title);
		} else {
		}
	}
	
	for(i = 0;i < timeTable.numX - 1;i++){
		drawDayString(timeTable.leftTopCalcIndex + i,day);
		
		switch(i){
		case 0:
			ctl = GetObjectPtr (DAYPUSHBTN2);
			break;
		case 1:
			ctl = GetObjectPtr (DAYPUSHBTN3);
			break;
		case 2:
			ctl = GetObjectPtr (DAYPUSHBTN4);
			break;
		case 3:
			ctl = GetObjectPtr (DAYPUSHBTN5);
			break;
		default:
			ctl = GetObjectPtr (DAYPUSHBTN2);/*1.2 Warninng ΍*/
		}
		
		CtlSetLabel (ctl, day);
	
	}
	
	drawCalcTime();
	
#if 0
	DrawBitmap(ARROW1BMPID,ARROW1POS_X,ARROWPOS_Y);
	DrawBitmap(ARROW2BMPID,ARROW2POS_X,ARROWPOS_Y);
	DrawBitmap(ARROW3BMPID,ARROW3POS_X,ARROWPOS_Y);
	DrawBitmap(ARROW4BMPID,ARROW4POS_X,ARROWPOS_Y);
#endif

}
//
//Zɕ
//
static void setStringsell(UInt16 index,Char *chr)
{
	UInt16 idx_x,idx_y;
	UInt16 posx,posy;	//Z̍W
	UInt16 length;
	Char s[64];				//*1.3.1*
	UInt16 pos=0;			//*1.3.1*ŌSJIF̈ʒu
	UInt16 i;				//*1.3.1*
	
	idx_x = index % timeTable.numX;
	idx_y = index / timeTable.numX;
	
	posx = timeTable.tablePosX + idx_x * timeTable.width;
	posy = timeTable.tablePosY + idx_y * timeTable.height;
	
	length = StrLen(chr);
//*1.3.1*	if(length > 5){
//*1.3.1*		length = 5;
//*1.3.1*	}
	
	//*1.3.1* length̏Cǉ
	if(length >= 6){
		for(i=0;i<6;i++){
			if(chr[i] & 0x80){
				pos=i;			//SJIS
				i++;			//SJISȂ̂ŃXLbv
			}
		}
		
		length = 6;
	}
	//*1.3.1*
	if(pos == 5){
		//6byteڂSJIS̍ŏ
		length = 5;
	}
	
	WinDrawChars("@@@",StrLen("@@@"),posx + 1,posy + 1);
	WinDrawChars(chr,length,posx + 1,posy + 1);


}
//
//Zɕ
//
static void setStringMidlesell(UInt16 index,Char *chr)
{
	UInt16 idx_x,idx_y;
	UInt16 posx,posy;	//Z̍W
	UInt16 length;
	
	idx_x = index % timeTable.numX;
	idx_y = index / timeTable.numX;
	
	posx = timeTable.tablePosX + idx_x * timeTable.width;
	posy = timeTable.tablePosY + idx_y * timeTable.height;
	
	length = StrLen(chr);
	if(length > 5){
		length = 5;
	}
	
	WinDrawChars("@@@",StrLen("@@@"),posx + 1,posy + 10);
	WinDrawChars(chr,length,posx + 1,posy + 10);

}
//
//Zɕ
//
static void setStringBtmsell(UInt16 index,Char *chr)
{
	UInt16 idx_x,idx_y;
	UInt16 posx,posy;	//Z̍W
	UInt16 length;
	
	idx_x = index % timeTable.numX;
	idx_y = index / timeTable.numX;
	
	posx = timeTable.tablePosX + idx_x * timeTable.width;
	posy = timeTable.tablePosY + idx_y * timeTable.height;
	
	length = StrLen(chr);
	if(length > 5){
		length = 5;
	}
	
	WinDrawChars("@@@",StrLen("@@@"),posx + 1,posy + 19);
	WinDrawChars(chr,length,posx + 1,posy + 19);

}
Boolean mainFrmSelectEvent(UInt16 ctrID)
{
	Boolean ret = false;
	
	switch(ctrID){
	case DAYPUSHBTN2:
	ret = true;
	break;
	case DAYPUSHBTN3:
	ret = true;
	break;
	case DAYPUSHBTN4:
	ret = true;
	break;
	case DAYPUSHBTN5:
	ret = true;
	break;
	}
	
	if(ret == true){
		FrmGotoForm (DayInfoForm);
	}
	
	return ret;
}
//
//
//
void checkTapRepeatBtn(UInt16 ctrID)
{
	switch(ctrID){
		
		case RepBtnUP:
			slideSellData(ARROW1_CLICKED);
			drawTimetable();
			break;

		case RepBtnDown:
			slideSellData(ARROW2_CLICKED);
			drawTimetable();
			break;

		case RepBtnReft:
			slideSellData(ARROW3_CLICKED);
			drawTimetable();
			break;

		case RepBtnRight:
			slideSellData(ARROW4_CLICKED);
			drawTimetable();
			break;
	}
}
//
//ZNbNꂽ`FbN
//
Boolean checkClickMainFrm(Int16 x,Int16 y)
{
	UInt16 index;
	UInt16 calcIdx;
	Boolean ret;
	UInt16 arrowType;
	
	ret = checkClickSell(x,y,&index);
	if(ret == true){
		
		if((index % timeTable.numX) == 0){
			FrmGotoForm(TimeInfoForm);
			getSellType(index,&calcIdx);
			initTimeForm(calcIdx);
		} else {
			FrmGotoForm(CalcInfoForm);
		}
	}
	
#if 0
	arrowType = checkClickArrow(x,y);
	if(arrowType != 0){
		slideSellData(arrowType);
		drawTimetable();
	}
#endif

	return ret;
}
//
//Z̃^bv
//
static Boolean checkClickSell(Int16 x,Int16 y,UInt16 *index)
{
	Int16 i,j;
	Int16 disx,disy;
	Boolean ret = false;
	
	for(i = 0;i < timeTable.numX;i++){
		
		disx = x - (i * timeTable.width + timeTable.tablePosX);
		
		for(j = 0;j < timeTable.numY;j++){
			
			disy = y - (j * timeTable.height + timeTable.tablePosY);
			
			if((disx > 0) && (disx < timeTable.width) 
				&& (disy > 0) && (disy < timeTable.height)){
				ret = true;
				*index = i + j * timeTable.numX;
				timeTable.selectedIndx = i + j * timeTable.numX;
				break;
			}
		}
		
		if(ret == true) break;
	}
	
	return ret;
}
//
//̃^bv
//
#if 0
static UInt16 checkClickArrow(Int16 x,Int16 y)
{
	Int16 disx,disy;
	UInt16 ret = NO_ARROWCLICED;
	
	disx = x - ARROW1POS_X;
	disy = y - ARROWPOS_Y;
	if((disx > 0) && (disx < ARROWSIZE)
		&& (disy > 0) && (disy < ARROWSIZE)){

		return ARROW1_CLICKED;
	}
	
	disx = x - ARROW2POS_X;
	if((disx > 0) && (disx < ARROWSIZE)
		&& (disy > 0) && (disy < ARROWSIZE)){

		return ARROW2_CLICKED;
	}
	
	disx = x - ARROW3POS_X;
	if((disx > 0) && (disx < ARROWSIZE)
		&& (disy > 0) && (disy < ARROWSIZE)){

		return ARROW3_CLICKED;
	}

	disx = x - ARROW4POS_X;
	if((disx > 0) && (disx < ARROWSIZE)
		&& (disy > 0) && (disy < ARROWSIZE)){
		
		return ARROW4_CLICKED;
	}

	return ret;
}
#endif
//
//̃^bv
//
static void slideSellData(UInt16 type)
{
	Int16 leftTopCalcIndex,leftTopTimeIndex;
	Int16 mod;
	
	leftTopCalcIndex = timeTable.leftTopCalcIndex;
	leftTopTimeIndex = timeTable.leftTopTimeIndex;
	switch(type){
		
	case ARROW1_CLICKED:
		leftTopCalcIndex -= ONEWEEKDAY;
		leftTopTimeIndex--;
		break;
		
	case ARROW2_CLICKED:
		leftTopCalcIndex += ONEWEEKDAY;
		leftTopTimeIndex++;
		break;
		
	case ARROW3_CLICKED:
		leftTopCalcIndex--;
		break;

	case ARROW4_CLICKED:
		leftTopCalcIndex++;
		break;
	}

	mod = leftTopCalcIndex % ONEWEEKDAY;
	
	if((leftTopCalcIndex >= 0) && (mod < timeTable.numX - 1)){
		if((leftTopTimeIndex >= 0) && (leftTopTimeIndex <= ONEDAYMAXCALC - timeTable.numY)){
			timeTable.leftTopCalcIndex = leftTopCalcIndex;
			timeTable.leftTopTimeIndex = leftTopTimeIndex;
		}
	}
}
//
//Ԋڍו\pf[^ݒ
//*1.2* ڍ׃tH[ʒmC^tF[XύX
void setCalcInfoFormData()
{
	UInt16 idx;
	Char day,time;
//	Char tmp[5];
	
	getSellType(timeTable.selectedIndx,&idx);
//*1.2*	initCalcFrm(&schedule.curc[idx]);
	
	time  = idx / ONEWEEKDAY + 1;		/*1.2*/
	day   = (idx % ONEWEEKDAY);		/*1.2*/
	initCalcFrm(day,time);				/*1.2*/
	
//FOR debug
//	StrIToA(tmp,timeTable.selectedIndx);
//	WinDrawChars(tmp,StrLen(tmp),10,0);
//	getSellType(timeTable.selectedIndx,&idx);
//	StrIToA(tmp,idx);
//	WinDrawChars(tmp,StrLen(tmp),10,20);

}
//
//Ԋf[^̃|C^擾
//
Schedule *getSchedulePtr()
{
	return &schedule;
}
//
//ZsellIdx̎ʂSchedulẽCfbNXԂ
//
static UInt16 getSellType(UInt16 sellIdx,UInt16 *ScheduleIdx)
{
	UInt16 ret = 0;
	UInt16 level;
	UInt16 offset;
	
	if((sellIdx % timeTable.numX) == 0){
		//ԏڍ
		*ScheduleIdx = (sellIdx / timeTable.numX) + timeTable.leftTopTimeIndex;// timeTable.numX;
		ret = TIMESELLTYPE;
	} else {
		//ȏڍ 
		level = sellIdx / timeTable.numX;//Z̉iڂ
		offset = (sellIdx % timeTable.numX) - 1;
		*ScheduleIdx = timeTable.leftTopCalcIndex + offset + level * ONEWEEKDAY;
		//sellIdx - (sellIdx / timeTable.numX + 1);
		ret = CULCSELLTYPE;
	}
	
	return ret;
}
//
//
//
Char getDayType(UInt16 CalcIndex)
{
	UInt16 mod;
	Char ret;
	
	mod = CalcIndex % ONEWEEKDAY;

	switch(mod){
		
	case 0:
		ret = MONDAY;
		break;
		
	case 1:
		ret = TUEDAY;
		break;
		
	case 2:
		ret = WESDAY;
		break;
		
	case 3:
		ret = THUDAY;
		break;
		
	case 4:
		ret = FRIDAY;
		break;
		
	case 5:
		ret = SATDAY;
		break;
		
	case 6:
		ret = SUNDAY;
		break;
		
	default:
		ret = 0;
	}

	return ret;
}
//*1.2
//j̕ZbgW[
//
void getDayString(Char dayType,Char *str)
{
	
	switch(dayType){
		
	case MONDAY:
		StrCopy(str,"");
		break;
		
	case TUEDAY:
		StrCopy(str,"");
		break;
		
	case WESDAY:
		StrCopy(str,"");
		break;
		
	case THUDAY:
		StrCopy(str,"");
		break;
		
	case FRIDAY:
		StrCopy(str,"");
		break;
		
	case SATDAY:
		StrCopy(str,"y");
		break;
		
	case SUNDAY:
		StrCopy(str,"");
		break;
		
	default:
		StrCopy(str,"error");
	}
	
}
//
//j̕\
//
static void drawDayString(UInt16 CalcIndex,Char *str)
{
	UInt16 mod;
	
	mod = CalcIndex % ONEWEEKDAY;
	
	getDayString(mod,str);	/*1.2*/
}
//
//̕\
//
static void drawCalcTime()
{
	Char text[10];
	Char tmp[6];
	UInt16 i;
	UInt16 index = 0;
	UInt16 time,hour;
	
	for(i = timeTable.leftTopTimeIndex;
		i < timeTable.leftTopTimeIndex + timeTable.numY;i++){
		StrIToA(text,i+1);
		appendChar(text,"");
		setStringsell(index,text);

		text[0]='\0';
		cnvertTime(schedule.time[i].startTime,&time,&hour);
		strIToAZero(tmp,time);
		appendChar(text,tmp);
		appendChar(text,":");
		strIToAZero(tmp,hour);
		appendChar(text,tmp);
		setStringMidlesell(index,text);

		text[0] = '\0';
		cnvertTime(schedule.time[i].endTime,&time,&hour);
		strIToAZero(tmp,time);
		appendChar(text,tmp);
		appendChar(text,":");
		strIToAZero(tmp,hour);
		appendChar(text,tmp);
		setStringBtmsell(index,text);
		
		index +=timeTable.numX;
	}
}
static void initCalcData()
{
	UInt16 i;
	
	for(i = 0;i < ONEDAYMAXCALC;i++){
		schedule.time[i].startTime = 0;
		schedule.time[i].endTime   = 0;
	}
}
//*1.1*
// n[h{^ǉ
// gpFAv{^Ƃ̘AglKv聨*1.3*L
//
Boolean keyDownTimeTableFrm(void)
{
	UInt32 keyType;
	Boolean ret = false;
	
	keyType = KeyCurrentState();
	
	if (keyType & 0x02) {       //Up
		slideSellData(ARROW1_CLICKED);
		drawTimetable();
		ret = true;
	} else if (keyType & 0x04) {//Down
		slideSellData(ARROW2_CLICKED);
		drawTimetable();
		ret = true;
	} else if (keyType & 0x10) {//left
		slideSellData(ARROW3_CLICKED);
		drawTimetable();
		ret = true;
	} else if (keyType & 0x20) {//right
		slideSellData(ARROW4_CLICKED);
		drawTimetable();
		ret = true;
	}
		
	return ret;
}
