/****************************************************************/
/*                                                              */
/*                       timeset.c                              */
/*       Taiga Yonekura 2000 All Rights Reserved                */
/****************************************************************/
/* Rev:  DATE    : contents                      :name          */
/*----:----------:-------------------------------:--------------*/
/*    :2000/10/14: ԐݒtH[p        :Taiga Yonkura */
/*    :          :                               :              */
/****************************************************************/
#include <PalmOS.h>

#include "timeRsc.h"
#include "timeTable.h"
#include "Comlib.h"

#define HOURMAX 23
#define MINMAX  59

static UInt16 addHour(UInt16);
static UInt16 decHour(UInt16);
static UInt16 addMin(UInt16);
static UInt16 decMin(UInt16);
static UInt16 cnvertTime2(UInt16 hour,UInt16 min);




static UInt16 shour;
static UInt16 smin;

static UInt16 ehour;
static UInt16 emin;

static UInt16 index;
//
//
//
void initTimeForm(UInt16 idx)
{
	UInt16 startTime;
	UInt16 endTime;
	
	index = idx;
	getCalcTime(idx,&startTime,&endTime);
	cnvertTime(startTime,&shour,&smin);
	cnvertTime(endTime,&ehour,&emin);
}
//
//
//
void closeTimeForm()
{
	UInt16 startTime;
	UInt16 endTime;

	startTime = cnvertTime2(shour,smin);
	endTime = cnvertTime2(ehour,emin);
	
	setCalcTime(index,startTime,endTime);
}
//
//
//
void drawTime()
{
	Char tmp[10];
	
	//JnԂ̕\
	StrIToA(tmp,shour);
	WinDrawChars("@@",StrLen("@@"),45,35);
	WinDrawChars(tmp,StrLen(tmp),45,35);

	//JnԂ̕\
	strIToAZero(tmp,smin);
	WinDrawChars("@@",StrLen("@@"),95,35);
	WinDrawChars(tmp,StrLen(tmp),95,35);

	//IԂ̕\
	StrIToA(tmp,ehour);
	WinDrawChars("@@",StrLen("@@"),45,85);
	WinDrawChars(tmp,StrLen(tmp),45,85);

	//IԂ̕\
	strIToAZero(tmp,emin);
	WinDrawChars("@@",StrLen("@@"),95,85);
	WinDrawChars(tmp,StrLen(tmp),95,85);

}
//
//
//
Boolean checkClickTimeFormBtn(UInt16 id)
{
	Boolean handled = false;
	
	switch(id){
	
	case TimeInfoFormHplusBtn:
		shour = addHour(shour);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormHminusBtn:
		shour = decHour(shour);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormMplusBtn:
		smin = addMin(smin);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormMminusBtn:
		smin = decMin(smin);
		drawTime();
		handled = true;
		break;

	case TimeInfoFormHplus2Btn:
		ehour = addHour(ehour);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormHminus2Btn:
		ehour = decHour(ehour);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormMplus2Btn:
		emin = addMin(emin);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormMminus2Btn:
		emin = decMin(emin);
		drawTime();
		handled = true;
		break;
		
	case TimeInfoFormOkBtn:
		//start{^ꂽƂ
		closeTimeForm();
		FrmGotoForm(MainForm);
		handled = true;
		break;

	case TimeInfoFormCancelBtn:
		//LZ{^ꂽƂ
		FrmGotoForm(MainForm);
		handled = true;
		break;
		
	default:
	}
	
	return handled;
}
//
//
//
static UInt16 addHour(UInt16 hour){
	
	if(hour >= HOURMAX){
		return 0;
	} else {
		return ++hour;
	}
}
//
//
//
static UInt16 decHour(UInt16 hour){
	
	if(hour <= 0){
		return HOURMAX;
	} else {
		return --hour;
	}
}
//
//
//
static UInt16 addMin(UInt16 min){
	
	if(min >= MINMAX){
		return 0;
	} else {
		return ++min;
	}
}
//
//
//
static UInt16 decMin(UInt16 min){
	
	if(min <= 0){
		return MINMAX;
	} else {
		return --min;
	}
}
static UInt16 cnvertTime2(UInt16 hour,UInt16 min)
{
	 return (60 * hour + min);
}
